
/*  A Bison parser, made from HeaderGrammar.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse HeaderGrammarparse
#define yylex HeaderGrammarlex
#define yyerror HeaderGrammarerror
#define yylval HeaderGrammarlval
#define yychar HeaderGrammarchar
#define yydebug HeaderGrammardebug
#define yynerrs HeaderGrammarnerrs
#define	INTERFACE	258
#define	PROTOCOL	259
#define	END	260
#define	BEGINUNION	261
#define	BEGINSTRUCT	262
#define	ENDSTRUCT	263
#define	IDENT	264
#define	AUTODOCCOMMENT	265
#define	COPYRIGHTCOMMENT	266
#define	STATICTYPE	267
#define	VARDECL	268
#define	FUNCTION	269
#define	GLOBALVAR	270
#define	CONSTANT	271
#define	MACRO	272
#define	TYPEDEF	273
#define	ENUM	274
#define	ELLIPSIS	275
#define	METHODSTART	276

#line 1 "HeaderGrammar.y"

//
//	HeaderGrammar.y
//	  Written by Carl Lindberg Copyright 1998 by Carl Lindberg.
//                     All rights reserved.
//		This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

	#import <Foundation/NSDictionary.h>
	#import <Foundation/NSPathUtilities.h>
	#import <Foundation/NSUtilities.h>
	#import <MiscFoundation.subproj/NSString+MiscRegex.h>
	#import <stdio.h>
	#import <stdlib.h>
	#import <string.h>

	#import "ADClass.h"
	#import "ADComment.h"
	#import "ADProtocol.h"
	#import "ADCompoundIvar.h"
	#import "ADCategory.h"
	#import "ADMethod.h"
	#import "ADMacro.h"
	#import "ADConstant.h"
	#import "ADGlobalVariable.h"
	#import "ADFunction.h"
	#import "ADTypedef.h"
	#import "ADFile.h"
		
	/* Is there a better way to handle this? */
	#undef yylex
	#define yylex HeaderTokenizerlex
	
	/* Define some strings, since we can't use constant strings inside bison rules */
	#define EMPTYSTRING @""
	#define UNIONSTRING @"union"
	#define STRUCTSTRING @"struct"
	
	typedef struct _MethodArg {
		NSString *argName;
		NSString *argType;
		NSString *varName;
	} MethodArg;
	
	
	int yyerror(char *s);
	int yylex();

	static ADHeaderEntity *lastEntity = nil;
	static ADComment *currentComment = nil;

	#define YYDEBUG 1
	#define YYERROR_VERBOSE 1
	
//	YYPARSE_PARAM doesn't work because of a snafu in bison.simple
//	#define YYPARSE_PARAM fileContents
//	#define ADFILE (ADFile *)fileContents
	static ADFile *globalFileContents;
	#define ADFILE (ADFile *)globalFileContents

#line 103 "HeaderGrammar.y"
typedef union
{
	NSString *stringVal;
	int		intVal;
	char	charVal;
	MethodArg  methodArg;
	NSArray  *array;
	NSMutableArray *mutableArray;
	id	 object;
	ADMethod *method;
	ADIvar *ivar;
	ADComment *comment;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		79
#define	YYFLAG		-32768
#define	YYNTBASE	31

#define YYTRANSLATE(x) ((unsigned)(x) <= 276 ? yytranslate[x] : 45)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    23,
    24,     2,     2,    27,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    22,    30,    25,
     2,    26,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    28,     2,    29,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,    14,    21,    30,    36,    38,    40,    42,
    44,    46,    48,    50,    52,    53,    57,    59,    63,    64,
    68,    69,    72,    75,    79,    83,    85,    86,    88,    89,
    92,    99,   101,   103,   104,   107,   108,   110,   111,   114,
   119,   123,   126,   130
};

static const short yyrhs[] = {    -1,
    31,    32,     0,     3,     9,    22,     9,    33,    38,    35,
    39,     5,     0,     3,     9,    33,    35,    39,     5,     0,
     3,     9,    23,     9,    24,    33,    39,     5,     0,     4,
     9,    33,    39,     5,     0,    10,     0,    11,     0,    14,
     0,    15,     0,    16,     0,    17,     0,    18,     0,    19,
     0,     0,    25,    34,    26,     0,     9,     0,     9,    27,
    34,     0,     0,    28,    36,    29,     0,     0,    36,    37,
     0,    13,    38,     0,     6,    36,     8,     0,     7,    36,
     8,     0,     1,     0,     0,    10,     0,     0,    39,    40,
     0,    21,    42,     9,    43,    41,    30,     0,    10,     0,
     1,     0,     0,    27,    20,     0,     0,    12,     0,     0,
    43,    44,     0,     9,    22,    12,     9,     0,    22,    12,
     9,     0,    22,     9,     0,     9,    22,     9,     0,     1,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   119,   120,   138,   150,   159,   168,   176,   181,   186,   191,
   196,   201,   206,   211,   218,   219,   222,   223,   226,   227,
   229,   230,   232,   237,   243,   249,   252,   253,   256,   257,
   259,   268,   272,   277,   278,   281,   282,   285,   289,   296,
   302,   308,   314,   320
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","INTERFACE",
"PROTOCOL","END","BEGINUNION","BEGINSTRUCT","ENDSTRUCT","IDENT","AUTODOCCOMMENT",
"COPYRIGHTCOMMENT","STATICTYPE","VARDECL","FUNCTION","GLOBALVAR","CONSTANT",
"MACRO","TYPEDEF","ENUM","ELLIPSIS","METHODSTART","':'","'('","')'","'<'","'>'",
"','","'{'","'}'","';'","file","filepiece","conforms","manyconforms","vardecls",
"manyvardecls","vardecl","maybecomment","manymethods","method","maybeellipsis",
"statictype","arguments","argument", NULL
};
#endif

static const short yyr1[] = {     0,
    31,    31,    32,    32,    32,    32,    32,    32,    32,    32,
    32,    32,    32,    32,    33,    33,    34,    34,    35,    35,
    36,    36,    37,    37,    37,    37,    38,    38,    39,    39,
    40,    40,    40,    41,    41,    42,    42,    43,    43,    44,
    44,    44,    44,    44
};

static const short yyr2[] = {     0,
     0,     2,     9,     6,     8,     5,     1,     1,     1,     1,
     1,     1,     1,     1,     0,     3,     1,     3,     0,     3,
     0,     2,     2,     3,     3,     1,     0,     1,     0,     2,
     6,     1,     1,     0,     2,     0,     1,     0,     2,     4,
     3,     2,     3,     1
};

static const short yydefact[] = {     1,
     0,     0,     0,     7,     8,     9,    10,    11,    12,    13,
    14,     2,    15,    15,     0,     0,     0,    19,    29,    15,
     0,    17,     0,    21,    29,     0,    27,    15,     0,    16,
     0,     0,    33,     6,    32,    36,    30,    28,    19,    29,
    18,    26,    21,    21,    27,    20,    22,     4,    37,     0,
    29,     0,     0,     0,    23,    38,     0,     5,    24,    25,
     0,     3,    44,     0,     0,     0,     0,    39,     0,    42,
     0,    35,    31,    43,     0,    41,    40,     0,     0
};

static const short yydefgoto[] = {     1,
    12,    18,    23,    25,    31,    47,    39,    26,    37,    67,
    50,    61,    68
};

static const short yypact[] = {-32768,
    37,    -8,     4,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    20,   -11,    15,    26,    27,    16,-32768,   -11,
    22,    32,    23,-32768,-32768,     2,    58,   -11,    27,-32768,
     3,    10,-32768,-32768,-32768,    62,-32768,-32768,    16,-32768,
-32768,-32768,-32768,-32768,    58,-32768,-32768,-32768,-32768,    66,
-32768,    17,    56,    59,-32768,-32768,    29,-32768,-32768,-32768,
    -1,-32768,-32768,    54,    49,    51,    47,-32768,    61,-32768,
    69,-32768,-32768,-32768,    70,-32768,-32768,    80,-32768
};

static const short yypgoto[] = {-32768,
-32768,     5,    52,    43,   -38,-32768,    38,   -23,-32768,-32768,
-32768,-32768,-32768
};


#define	YYLAST		83


static const short yytable[] = {    63,
    13,    32,    33,    42,    53,    54,    34,    64,    43,    44,
    33,    35,    14,    17,    48,    45,    52,    33,    19,    35,
    65,    58,    36,    20,    27,    66,    35,    57,   -34,    33,
    36,    46,    40,    62,    21,    22,    78,    36,    35,     2,
     3,    15,    16,    24,    17,    28,     4,     5,    30,    36,
     6,     7,     8,     9,    10,    11,    42,    70,    29,    42,
    71,    43,    44,    59,    43,    44,    60,    38,    45,    74,
    72,    45,    75,    49,    56,    69,    73,    76,    77,    79,
    41,    51,    55
};

static const short yycheck[] = {     1,
     9,    25,     1,     1,    43,    44,     5,     9,     6,     7,
     1,    10,     9,    25,     5,    13,    40,     1,    14,    10,
    22,     5,    21,     9,    20,    27,    10,    51,    30,     1,
    21,    29,    28,     5,     9,     9,     0,    21,    10,     3,
     4,    22,    23,    28,    25,    24,    10,    11,    26,    21,
    14,    15,    16,    17,    18,    19,     1,     9,    27,     1,
    12,     6,     7,     8,     6,     7,     8,    10,    13,     9,
    20,    13,    12,    12,     9,    22,    30,     9,     9,     0,
    29,    39,    45
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/Developer/Executables/Support/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/Developer/Executables/Support/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 121 "HeaderGrammar.y"
{
			if ([yyvsp[0].object isKindOfClass:[ADHeaderEntity class]])
			{
				if (currentComment)
				{
					[yyvsp[0].object setEntityDescription:currentComment];
					currentComment = nil;
				}
				else if ([yyvsp[0].object isMemberOfClass:[lastEntity class]])
				{
					[yyvsp[0].object setRelatedToPreviousEntity:YES];
				}
				lastEntity = yyvsp[0].object;
			}
		;
    break;}
case 3:
#line 139 "HeaderGrammar.y"
{
				yyval.object = [[[ADClass alloc] init] autorelease];
				[yyval.object setClassName:yyvsp[-7].stringVal];
				[yyval.object setSuperclassName:yyvsp[-5].stringVal];
				[yyval.object setConformedProtocols:yyvsp[-4].mutableArray];
				[yyval.object setInheritsInfo:yyvsp[-3].comment];
				[yyval.object setIvarArray:yyvsp[-2].mutableArray];
				[yyval.object addDeclarationsFromArray:yyvsp[-1].mutableArray];
				[ADFILE addClass:yyval.object];
			;
    break;}
case 4:
#line 151 "HeaderGrammar.y"
{
				yyval.object = [[[ADClass alloc] init] autorelease];
				[yyval.object setClassName:yyvsp[-4].stringVal];
				[yyval.object setConformedProtocols:yyvsp[-3].mutableArray];
				[yyval.object setIvarArray:yyvsp[-2].mutableArray];
				[yyval.object addDeclarationsFromArray:yyvsp[-1].mutableArray];
				[ADFILE addClass:yyval.object];
			;
    break;}
case 5:
#line 160 "HeaderGrammar.y"
{
				yyval.object = [ADCategory category];
				[yyval.object setClassName:yyvsp[-6].stringVal];
				[yyval.object setCategoryName:yyvsp[-4].stringVal];
				[yyval.object setConformedProtocols:yyvsp[-2].mutableArray];
				[yyval.object addDeclarationsFromArray:yyvsp[-1].mutableArray];
				[ADFILE addCategory:yyval.object];
			;
    break;}
case 6:
#line 169 "HeaderGrammar.y"
{
				yyval.object = [ADProtocol protocol];
				[yyval.object setProtocolName:yyvsp[-3].stringVal];
				[yyval.object setConformedProtocols:yyvsp[-2].mutableArray];
				[yyval.object addDeclarationsFromArray:yyvsp[-1].mutableArray];
				[ADFILE addProtocol:yyval.object];
			;
    break;}
case 7:
#line 177 "HeaderGrammar.y"
{
				yyval.object = [ADComment commentWithString:yyvsp[0].stringVal];
				currentComment = yyval.object;
			;
    break;}
case 8:
#line 182 "HeaderGrammar.y"
{
				yyval.object = nil;
				[ADFILE setCopyrightFromString:yyvsp[0].stringVal];
			;
    break;}
case 9:
#line 187 "HeaderGrammar.y"
{
				yyval.object = [ADFunction functionWithString:yyvsp[0].stringVal];
				[ADFILE addFunction:yyval.object];
			;
    break;}
case 10:
#line 192 "HeaderGrammar.y"
{
				yyval.object = [ADGlobalVariable variableWithString:yyvsp[0].stringVal];
				[ADFILE addVariable:yyval.object];
			;
    break;}
case 11:
#line 197 "HeaderGrammar.y"
{
				yyval.object = [ADConstant constantWithString:yyvsp[0].stringVal];
				[ADFILE addConstant:yyval.object];
			;
    break;}
case 12:
#line 202 "HeaderGrammar.y"
{
				yyval.object = [ADMacro macroWithString:yyvsp[0].stringVal];
				[ADFILE addMacro:yyval.object];
			;
    break;}
case 13:
#line 207 "HeaderGrammar.y"
{
				yyval.object = [ADTypedef typedefWithString:yyvsp[0].stringVal];
				[ADFILE addTypedef:yyval.object];
			;
    break;}
case 14:
#line 212 "HeaderGrammar.y"
{
				/* Not handling these yet */
				yyval.object = nil;
			;
    break;}
case 15:
#line 218 "HeaderGrammar.y"
{ yyval.mutableArray = [NSMutableArray array]; ;
    break;}
case 16:
#line 219 "HeaderGrammar.y"
{ yyval.mutableArray = yyvsp[-1].mutableArray; ;
    break;}
case 17:
#line 222 "HeaderGrammar.y"
{ yyval.mutableArray = [NSMutableArray arrayWithObject:yyvsp[0].stringVal]; ;
    break;}
case 18:
#line 223 "HeaderGrammar.y"
{ yyval.mutableArray = yyvsp[0].mutableArray; [yyval.mutableArray addObject:yyvsp[-2].stringVal]; ;
    break;}
case 19:
#line 226 "HeaderGrammar.y"
{ yyval.mutableArray = [NSMutableArray array]; ;
    break;}
case 20:
#line 227 "HeaderGrammar.y"
{ yyval.mutableArray = yyvsp[-1].mutableArray; ;
    break;}
case 21:
#line 229 "HeaderGrammar.y"
{ yyval.mutableArray = [NSMutableArray array]; ;
    break;}
case 22:
#line 230 "HeaderGrammar.y"
{ yyval.mutableArray = yyvsp[-1].mutableArray; if (yyvsp[0].ivar) [yyval.mutableArray addObject:yyvsp[0].ivar]; ;
    break;}
case 23:
#line 233 "HeaderGrammar.y"
{
				yyval.ivar = [ADIvar ivarWithString:yyvsp[-1].stringVal];
				if (yyvsp[0].comment) [yyval.ivar setEntityDescription:yyvsp[0].comment];
			;
    break;}
case 24:
#line 238 "HeaderGrammar.y"
{
				yyval.ivar = [ADCompoundIvar ivarWithString:yyvsp[0].stringVal];
				[(ADCompoundIvar *)yyval.ivar setSubIvars:yyvsp[-1].mutableArray];
				[(ADCompoundIvar *)yyval.ivar setType:UNIONSTRING];
			;
    break;}
case 25:
#line 244 "HeaderGrammar.y"
{
				yyval.ivar = [ADCompoundIvar ivarWithString:yyvsp[0].stringVal];
				[(ADCompoundIvar *)yyval.ivar setSubIvars:yyvsp[-1].mutableArray];
				[(ADCompoundIvar *)yyval.ivar setType:STRUCTSTRING];
			;
    break;}
case 26:
#line 249 "HeaderGrammar.y"
{ yyval.ivar = nil; ;
    break;}
case 27:
#line 252 "HeaderGrammar.y"
{yyval.comment = nil; ;
    break;}
case 28:
#line 253 "HeaderGrammar.y"
{ yyval.comment = [ADComment commentWithString:yyvsp[0].stringVal]; ;
    break;}
case 29:
#line 256 "HeaderGrammar.y"
{ yyval.mutableArray = [NSMutableArray array]; ;
    break;}
case 30:
#line 257 "HeaderGrammar.y"
{ yyval.mutableArray = yyvsp[-1].mutableArray; if (yyvsp[0].method) [yyval.mutableArray addObject:yyvsp[0].method]; ;
    break;}
case 31:
#line 260 "HeaderGrammar.y"
{
				yyval.method = yyvsp[-2].method;
				[yyval.method setClassMethod:(yyvsp[-5].charVal == '+')];
				[yyval.method setReturnType:yyvsp[-4].stringVal];
				[yyval.method setFirstArgumentName:yyvsp[-3].stringVal];
				if ([yyvsp[-1].stringVal length] > 0)
					[yyval.method setIsVarargMethod:YES];
			;
    break;}
case 32:
#line 269 "HeaderGrammar.y"
{
				yyval.method = (ADMethod *)[ADComment commentWithString:yyvsp[0].stringVal];
			;
    break;}
case 33:
#line 272 "HeaderGrammar.y"
{ yyval.method = nil; ;
    break;}
case 34:
#line 277 "HeaderGrammar.y"
{yyval.stringVal = EMPTYSTRING;;
    break;}
case 35:
#line 278 "HeaderGrammar.y"
{yyval.stringVal = yyvsp[0].stringVal; ;
    break;}
case 36:
#line 281 "HeaderGrammar.y"
{yyval.stringVal = EMPTYSTRING; ;
    break;}
case 37:
#line 282 "HeaderGrammar.y"
{yyval.stringVal = yyvsp[0].stringVal; ;
    break;}
case 38:
#line 286 "HeaderGrammar.y"
{
				yyval.method = [ADMethod method];
			;
    break;}
case 39:
#line 290 "HeaderGrammar.y"
{
				yyval.method = yyvsp[-1].method;
				[yyval.method addArgument:yyvsp[0].methodArg.argName type:yyvsp[0].methodArg.argType varName:yyvsp[0].methodArg.varName];
			;
    break;}
case 40:
#line 297 "HeaderGrammar.y"
{
				yyval.methodArg.argName = yyvsp[-3].stringVal;
				yyval.methodArg.argType = yyvsp[-1].stringVal;
				yyval.methodArg.varName = yyvsp[0].stringVal;
			;
    break;}
case 41:
#line 303 "HeaderGrammar.y"
{
				yyval.methodArg.argName = EMPTYSTRING;
				yyval.methodArg.argType = yyvsp[-1].stringVal;
				yyval.methodArg.varName = yyvsp[0].stringVal;
			;
    break;}
case 42:
#line 309 "HeaderGrammar.y"
{
				yyval.methodArg.argName = EMPTYSTRING;
				yyval.methodArg.argType = EMPTYSTRING;
				yyval.methodArg.varName = yyvsp[0].stringVal;
			;
    break;}
case 43:
#line 315 "HeaderGrammar.y"
{
				yyval.methodArg.argName = yyvsp[-2].stringVal;
				yyval.methodArg.argType = EMPTYSTRING;
				yyval.methodArg.varName = yyvsp[0].stringVal;
			;
    break;}
case 44:
#line 321 "HeaderGrammar.y"
{
				yyval.methodArg.argName = EMPTYSTRING;
				yyval.methodArg.argType = EMPTYSTRING;
				yyval.methodArg.varName = EMPTYSTRING;
			;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/Developer/Executables/Support/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 326 "HeaderGrammar.y"


extern void ADSetHeaderFile(FILE *file);

void ADParseHeaderFile(ADFile *fileContents)
{
	FILE *headerFile;
	
	//yydebug = 1;

	if ([fileContents headerFilename])
	{
		headerFile = fopen([[fileContents headerFilename] cString], "r");
		ADSetHeaderFile(headerFile);
		globalFileContents = fileContents;
		lastEntity = nil;
                currentComment = nil;
		yyparse();
		fclose(headerFile);
	}
}


int yyerror(char *s)
{
	fprintf(stderr, "%s\n", s);
	return 1;
}



