//
//	ADEntity.h
//	  Written by Carl Lindberg Copyright 1998 by Carl Lindberg.
//                     All rights reserved.
//		This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <Foundation/NSObject.h>

@class ADComment;
@class NSString, NSArray;

@interface ADEntity : NSObject
{
	ADComment	*entityDescription;
}

- (void)setEntityDescription:(ADComment *)comment;
- (ADComment *)entityDescription;

- (void)setDescriptionString:(NSString *)aString;

- (NSArray *)wordsToItalicize;

@end
