//
//	ADMacro.h
//	  Written by Carl Lindberg Copyright 1998 by Carl Lindberg.
//                     All rights reserved.
//		This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "ADHeaderEntity.h"

@interface ADMacro : ADHeaderEntity
{
	NSString *name;
	NSString *parameterString;
}

+ macroWithString:(NSString *)string;
- initWithString:(NSString *)string;

- (NSString *)name;
- (NSString *)parameterString;

@end

